if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_racs_HoursWorked]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_racs_HoursWorked]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE sp_racs_HoursWorked
    @FilterUser varchar(20)
   ,@FilterAccountNo varchar(20)
   ,@FilterStartDate varchar(20)
   ,@FilterEndDate varchar(20)
   ,@ShowInCompleteOnly TinyInt
AS

SET DATEFORMAT dmy
declare @FilterStartDateStart DateTime
declare @FilterStartDateEnd   DateTime

if IsDate(@FilterStartDate) = 0
Begin
	Set @FilterStartDate = GetDate()
	Set @FilterStartDate = Convert(DateTime, (DateName(Year,@FilterStartDate) + '-' + DateName(Month,@FilterStartDate) + '-01'),120)
End

if IsDate(@FilterEndDate) = 0
Begin
	Set @FilterEndDate = DateAdd(Month,1,@FilterStartDate) - 1
End

set @FilterStartDateStart = Convert(DateTime, (DateName(Year,@FilterStartDate) + '-' + DateName(Month,@FilterStartDate) + '-' + DateName(Day,@FilterStartDate)),120)
set @FilterStartDateEnd   = Convert(DateTime, (DateName(Year,@FilterEndDate) + '-' + DateName(Month,@FilterEndDate) + '-' + DateName(Day,@FilterEndDate)),120)

if (@FilterStartDateEnd < @FilterStartDateStart)
Begin
	Set @FilterStartDateEnd = @FilterStartDateStart
End

Set @FilterStartDateEnd = @FilterStartDateEnd + 1

-- Set @FilterUser = ltrim(rtrim(@FilterUser)) + '%'
-- Set @FilterAccountNo = ltrim(rtrim(@FilterAccountNo)) + '%'

-- This is for showing billed labour hours
select
   SM_Service.ServiceNo
   ,SM_Service.AccountNo
   ,case when (@ShowInCompleteOnly = 0) then HR_Staff.FName else 'CalendarListOnly' End as FName
   ,SM_Job.JobNo
   ,SubString(SM_Job.Description,1,200) AS Description
   ,SM_Job.DateLogged
   ,SM_Status.StatusDesc
   ,SubString(SM_JobLabour.Description,1,200) as LineItemDescription
   ,SM_JobLabour.StartTime
   ,SM_JobLabour.EndTime
   ,(Coalesce(SM_LabourLineDetail.Quantity,SM_JobLabour.ElapsedTime,0)) as 'ElapsedTime'
   ,(Coalesce(SM_LabourLineDetail.Quantity,SM_JobLabour.BillingTime,0)) as 'BillingTime'
   ,(Coalesce(SM_LabourLineDetail.Quantity * SM_LabourLineDetail.Rate, SM_JobLabour.BillingTime * SM_JobLabour.Rate, 0)) AS 'LineTotal'
   ,SM_JobLabour.LabourID
from SM_Service 
inner join SM_Job
  on SM_Service.ServiceID = SM_Job.ServiceID
inner join SM_Status
  on SM_Job.Status = SM_Status.StatusID
inner join SM_JobLabour
  on SM_Job.JobID = SM_JobLabour.JobID
inner join HR_Staff
  on SM_JobLabour.StaffID = HR_Staff.StaffID
left outer join SM_LabourLineDetail
	on SM_JobLabour.LabourID = SM_LabourLineDetail.LabourID

where (SM_Job.CompletionID = '')
 and ((@FilterUser = '') or (HR_Staff.FName = @FilterUser))
 and ((@FilterAccountNo = '') or (SM_Service.AccountNo = @FilterAccountNo))
 and ((@ShowInCompleteOnly = 0) or ((SM_Status.StatusDesc <> 'Complete') and (SM_Status.StatusDesc <> 'Waiting-Billing') and (SM_Status.StatusDesc <> 'Unavailable')))
 and ((@FilterStartDate = '')
	or ((SM_JobLabour.StartTime >= @FilterStartDateStart) and (SM_JobLabour.StartTime <  @FilterStartDateEnd))
	or ((SM_JobLabour.StartTime <  @FilterStartDateStart) and (SM_JobLabour.EndTime   >  @FilterStartDateStart)))

order by HR_Staff.FName, SM_JobLabour.StartTime
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

GRANT  EXECUTE  ON [dbo].[sp_racs_HoursWorked]  TO [JiwaUser]
GO

GRANT  EXECUTE  ON [dbo].[sp_racs_HoursWorked]  TO [JiwaReports]
GO
